From 0dd8f1715dc20723e76d4b72d05f14b480c7ba13 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 34/48] migrate ModuleArtifacts to TreeObj/RPMsMixin


---

diff --git a/modulemd/artifacts.py b/modulemd/artifacts.py
index b42d75d..e575f2f 100644
--- a/modulemd/artifacts.py
+++ b/modulemd/artifacts.py
@@ -22,78 +22,28 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
+from .legacy_wrappers import TreeObj, RPMsMixin
+
+
 supported_content = ("rpms",)
 
-from gi.repository import Modulemd
 
-class ModuleArtifacts(object):
+class ModuleArtifacts(TreeObj, RPMsMixin):
     """Class representing a particular module artifacts."""
 
-    def __init__(self, parent=None):
+    tree_identity = 'artifacts'
+
+    def __init__(self, rpms=None, parent=None):
         """Creates a new ModuleArtifacts instance."""
-        self.rpms = set()
-        self.parent = parent
+        super(ModuleArtifacts, self).__init__(parent=parent)
+        if rpms:
+            self.rpms = rpms
 
     def __repr__(self):
         return "<ModuleArtifacts: rpms: {!r}>".format(sorted(self.rpms))
 
-    def __bool__(self):
-        return True if self.rpms else False
-
-    __nonzero__ = __bool__
-
-    @property
-    def rpms(self):
-        """A set of NEVRAs listing this module's RPM artifacts."""
-        return self._rpms
-
-    @rpms.setter
-    def rpms(self, ss):
-        if not isinstance(ss, set):
-            raise TypeError("artifacts.rpms: data type not supported")
-        for v in ss:
-            if not isinstance(v, str):
-                raise TypeError("artifacts.rpms: data type not supported")
-        self._rpms = ss
-
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_artifacts(ss)
-
-    def add_rpm(self, s):
-        """Adds an NEVRA to the artifact set.
-
-        :param str s: RPM NEVRA
-        """
-        if not isinstance(s, str):
-            raise TypeError("artifacts.add_rpm: data type not supported")
-        self._rpms.add(s)
-
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_artifacts(ss)
-
-    def del_rpm(self, s):
-        """Removes the supplied NEVRA from the artifact set.
-
-        :param str s: RPM NEVRA
-        """
-        if not isinstance(s, str):
-            raise TypeError("artifacts.del_rpm: data type not supported")
-        self._rpms.discard(s)
-
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_artifacts(ss)
-
-    def clear_rpms(self):
-        """Clear the RPM artifacts set."""
-        self._rpms.clear()
+    def get_rpm_set(self):
+        return self.parent.module.get_rpm_artifacts()
 
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_artifacts(ss)
+    def set_rpm_set(self, ss):
+        self.parent.module.set_rpm_artifacts(ss)

